import React from 'react';
import Button from '@material-ui/core/Button';
import TextField from '@material-ui/core/TextField';
import SaveIcon from '@material-ui/icons/Save';
import { makeStyles } from '@material-ui/core/styles';
import AddAPhotoIcon from '@material-ui/icons/AddAPhoto';
import './App.scss';
import {useState, useEffect} from "react";
import {useDispatch, useSelector, connect} from "react-redux";
import {actionUpdateMe} from '../../App.js';
import {useParams} from 'react-router-dom';


const useStyles = makeStyles((theme) => ({
  root: {
    height: '50vh',
  },
  paper: {
    margin: theme.spacing(8, 4),
    display: 'flex',
    flexDirection: 'column',
    alignItems: 'center',
  },
  
  form: {
    width: '100%', // Fix IE 11 issue.
    marginTop: theme.spacing(1),
  },
  submit: {
    margin: theme.spacing(3, 0, 2),
  },
}));

 function MyProfile({loadData, myUser=[] }) {
  const id = useSelector(state => state.auth?.payload?.sub?.id)
  useEffect(() => {
    loadData(id)
},[id])
  const dispatch = useDispatch();
  const [user, setUser] = useState(myUser)
  const [profile, setProfile] = useState({ login:'', nick: '', addresses:'', phones:''});
  useEffect(() => {
    if(myUser!==[]){
        setProfile({ login:myUser.login, nick:myUser.nick, addresses:myUser.addresses, phones:myUser.phones})
    }
},[myUser])

  const classes = useStyles();
  return (
    <main className="main1">
        <div className="banner-wrap" >
          <div className="conteiner">
            <div className="flex__box">
              <div className="conteiner__images__pc">
                <img className="imgx" src="https://d18jg6w55vcmy1.cloudfront.net/media/resume_images/38beb2471ba34320baae996ce289a7ed.png" alt=""/>
                <div className="buttonPhoto">
                <Button
              type="submit"
              fullWidth
              variant="outlined"
              color='primary'
              startIcon={<AddAPhotoIcon />}>
              Сhange photo
            </Button>
                </div>
              </div>
              <div className="banner">
                <TextField
              variant="outlined"
              margin="normal"
              required
              fullWidth
              id="Login"
              label="Login"
              name="Login"
              autoComplete="Login"
              autoFocus
              value={profile.login}
              onChange={(e) => setProfile({...profile, login: e.target.value})}
            />
            <TextField
              variant="outlined"
              margin="normal"
              required
              fullWidth
              id="Name"
              label="Name"
              name="Name"
              autoComplete="Name"
              autoFocus
              value={profile.nick}
              onChange={(e) => setProfile({...profile, nick: e.target.value})}
            />
            <TextField
              variant="outlined"
              margin="normal"
              required
              fullWidth
              id="Number phone"
              label="Number phone"
              name="Number phone"
              autoComplete="Number phone"
              autoFocus
              value={profile.phones}
              onChange={(e) => setProfile({...profile, phones: e.target.value})}
            />
            <TextField
              variant="outlined"
              margin="normal"
              required
              fullWidth
              id="City"
              label="City"
              name="City"
              autoComplete="City"
              autoFocus
              value={profile.addresses}
              onChange={(e) => setProfile({...profile, addresses: e.target.value})}
            />
            <Button
              onClick={() => {dispatch(actionUpdateMe({...profile, _id: id}))}}
              type="submit"
              fullWidth
              variant="contained"
              color="primary"
              className={classes.submit}
              startIcon={<SaveIcon />}
            >
              Сhange profile
            </Button>
                
               </div>
            </div>
          </div>
        </div>
    </main>
  );
}



export default MyProfile